## This is the function that runs
## constantly while the players
## are in the maze section

## RESET IF STEP OFF PATH
execute if score @p MazeLevel matches 1..4 as @p[tag=p1] at @s unless block ~ ~-3 ~ magenta_terracotta run function henzoid:maze/mazereset
execute if score @p MazeLevel matches 1..4 as @p[tag=p2] at @s unless block ~ ~-3 ~ blue_terracotta run function henzoid:maze/mazereset
execute if score @p MazeLevel matches 1..4 as @p[tag=p3] at @s unless block ~ ~-3 ~ green_terracotta run function henzoid:maze/mazereset
execute if score @p MazeLevel matches 1..4 as @p[tag=p4] at @s unless block ~ ~-3 ~ yellow_terracotta run function henzoid:maze/mazereset

## CHECK IF LEVEL FINISHED
execute if score @p MazeLevel matches 1 at @p[tag=p1] if block ~ ~-2 ~ diamond_block at @p[tag=p2] if block ~ ~-2 ~ diamond_block at @p[tag=p3] if block ~ ~-2 ~ diamond_block at @p[tag=p4] if block ~ ~-2 ~ diamond_block run fill 36 104 157 35 103 81 air replace end_stone_brick_wall
execute if score @p MazeLevel matches 1 at @p[tag=p1] if block ~ ~-2 ~ diamond_block at @p[tag=p2] if block ~ ~-2 ~ diamond_block at @p[tag=p3] if block ~ ~-2 ~ diamond_block at @p[tag=p4] if block ~ ~-2 ~ diamond_block run function henzoid:dialogue/maze/instructions_2
execute if score @p MazeLevel matches 1 at @p[tag=p1] if block ~ ~-2 ~ diamond_block at @p[tag=p2] if block ~ ~-2 ~ diamond_block at @p[tag=p3] if block ~ ~-2 ~ diamond_block at @p[tag=p4] if block ~ ~-2 ~ diamond_block run scoreboard players set @a MazeLevel 2
execute if score @p MazeLevel matches 2 at @p[tag=p1] if block ~ ~-2 ~ gold_block at @p[tag=p2] if block ~ ~-2 ~ gold_block at @p[tag=p3] if block ~ ~-2 ~ gold_block at @p[tag=p4] if block ~ ~-2 ~ gold_block run fill 62 104 157 61 103 81 air replace end_stone_brick_wall
execute if score @p MazeLevel matches 2 at @p[tag=p1] if block ~ ~-2 ~ gold_block at @p[tag=p2] if block ~ ~-2 ~ gold_block at @p[tag=p3] if block ~ ~-2 ~ gold_block at @p[tag=p4] if block ~ ~-2 ~ gold_block run function henzoid:dialogue/maze/instructions_3
execute if score @p MazeLevel matches 2 at @p[tag=p1] if block ~ ~-2 ~ gold_block at @p[tag=p2] if block ~ ~-2 ~ gold_block at @p[tag=p3] if block ~ ~-2 ~ gold_block at @p[tag=p4] if block ~ ~-2 ~ gold_block run scoreboard players set @a MazeLevel 3
execute if score @p MazeLevel matches 3 at @p[tag=p1] if block ~ ~-2 ~ netherite_block at @p[tag=p2] if block ~ ~-2 ~ netherite_block at @p[tag=p3] if block ~ ~-2 ~ netherite_block at @p[tag=p4] if block ~ ~-2 ~ netherite_block run fill 88 104 157 87 103 81 air replace end_stone_brick_wall
execute if score @p MazeLevel matches 3 at @p[tag=p1] if block ~ ~-2 ~ netherite_block at @p[tag=p2] if block ~ ~-2 ~ netherite_block at @p[tag=p3] if block ~ ~-2 ~ netherite_block at @p[tag=p4] if block ~ ~-2 ~ netherite_block run function henzoid:dialogue/maze/instructions_4
execute if score @p MazeLevel matches 3 at @p[tag=p1] if block ~ ~-2 ~ netherite_block at @p[tag=p2] if block ~ ~-2 ~ netherite_block at @p[tag=p3] if block ~ ~-2 ~ netherite_block at @p[tag=p4] if block ~ ~-2 ~ netherite_block run scoreboard players set @a MazeLevel 4
execute if score @p MazeLevel matches 4 at @p[tag=p1] if block ~ ~-2 ~ raw_gold_block at @p[tag=p2] if block ~ ~-2 ~ raw_gold_block at @p[tag=p3] if block ~ ~-2 ~ raw_gold_block at @p[tag=p4] if block ~ ~-2 ~ raw_gold_block run function henzoid:transitions/3_init

## ARMORSTANDS
execute if score @p MazeLevel matches 1..4 as @p[tag=p1] at @s positioned ~ ~ ~24 rotated as @s run tp @e[tag=1_2,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p1] at @s positioned ~ ~ ~48 rotated as @s run tp @e[tag=1_3,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p1] at @s positioned ~ ~ ~72 rotated as @s run tp @e[tag=1_4,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p2] at @s positioned ~ ~ ~-24 rotated as @s run tp @e[tag=2_1,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p2] at @s positioned ~ ~ ~24 rotated as @s run tp @e[tag=2_3,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p2] at @s positioned ~ ~ ~48 rotated as @s run tp @e[tag=2_4,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p3] at @s positioned ~ ~ ~-48 rotated as @s run tp @e[tag=3_1,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p3] at @s positioned ~ ~ ~-24 rotated as @s run tp @e[tag=3_2,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p3] at @s positioned ~ ~ ~24 rotated as @s run tp @e[tag=3_4,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p4] at @s positioned ~ ~ ~-72 rotated as @s run tp @e[tag=4_1,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p4] at @s positioned ~ ~ ~-48 rotated as @s run tp @e[tag=4_2,limit=1] ~ ~ ~ ~ ~
execute if score @p MazeLevel matches 1..4 as @p[tag=p4] at @s positioned ~ ~ ~-24 rotated as @s run tp @e[tag=4_3,limit=1] ~ ~ ~ ~ ~

## NO TOUCHY
execute if score @p MazeLevel matches 2..4 as @a at @s if entity @e[type=armor_stand,distance=0..1,limit=1] run function henzoid:maze/mazereset

## SPEED
execute if score @p MazeLevel matches 2 run effect give @a[tag=funnyspeed] speed 1 100 true

## TIMER
execute if score @p MazeLevel matches 4 if score @p MazeTimer matches 1.. run scoreboard players remove @a MazeTimer 1
execute if score @p MazeLevel matches 4 if score @p MazeTimer matches 0 run function henzoid:transitions/3_init